package fmon

import com.fasterxml.jackson.databind.ObjectMapper
import com.fasterxml.jackson.dataformat.yaml.YAMLFactory
import com.fasterxml.jackson.module.scala.DefaultScalaModule

import scala.reflect.runtime.universe._
import scala.tools.reflect.ToolBox

import fmon.battle.BattleEngine
import fmon.stat._

case class Prop(url : Seq[String])

object Game {
  def main(args : Array[String]): Unit = {
    implicit val rng = new scala.util.Random()
    val form1 = Form("Diabolo")
    val form2 = Form("Chanilla")
    val movepool1 = IndexedSeq(Move("eruption"))
    val movepool2 = IndexedSeq(Move("flail"))
    val p1 = TrainerID("Jaeda", Gender.Female, 0)
    val p2 = TrainerID("Wild Monster", Gender.Male, 0)
    val party1 = new Party(p1, new MonsterPtr(Monster.generate("Allied Mon", p1, 500, form1, movepool1)), IndexedSeq())
    val party2 = new Party(p2, new MonsterPtr(Monster.generate("Wild Mon", p2, 500, form2, movepool2)), IndexedSeq(
        Monster.generate("Sideboard Mon", p2, 500, form2, movepool2)
        ))
    println(form1.xpCurve)
    val engine = new BattleEngine(party1, party2)
    engine.play()
    println(party1.lead.elements)
  }
}